## armadillo 6.500.5+dfsg

=== CMakeLists.txt ===

# Copyright (C) 2008-2015 National ICT Australia (NICTA)
# 
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.
# -------------------------------------------------------------------
# 
# Written by Conrad Sanderson - http://conradsanderson.id.au
# Written by Ryan Curtin
# Written by Clement Creusot



cmake_minimum_required(VERSION 2.8 FATAL_ERROR)

set(ARMA_MAJOR 6)
set(ARMA_MINOR 500)
set(ARMA_PATCH 5)
set(ARMADILLO_VERSION ${ARMA_MAJOR}.${ARMA_MINOR}.${ARMA_PATCH})

message(STATUS "Configuring Armadillo ${ARMADILLO_VERSION}")


## Set ARMA_USE_WRAPPER to false if you're getting linking errors when compiling your programs,
## or if you prefer to directly link with BLAS and/or LAPACK.
## You will then need to link your programs with -lblas -llapack instead of -larmadillo
## If you're using OpenBLAS, link your programs with -lopenblas -llapack instead of -larmadillo

set(ARMA_USE_WRAPPER true)


# the settings below will be automatically configured by the rest of this script

set(ARMA_USE_LAPACK           false)
set(ARMA_USE_BLAS             false)
set(ARMA_USE_ATLAS            false)
set(ARMA_USE_HDF5_ALT         false)
set(ARMA_USE_ARPACK           false)
set(ARMA_USE_EXTERN_CXX11_RNG false)
set(ARMA_USE_SUPERLU          false)  # Caveat: only SuperLU version 4.3 can be used!

project(armadillo CXX)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake_aux/Modules/")

include(CheckIncludeFileCXX)
include(CheckLibraryExists)

option(BUILD_SHARED_LIBS "build shared library" ON)
option(DETECT_HDF5 "Detect HDF5 and include HDF5 support, if found" OFF)

message(STATUS "CMAKE_SYSTEM_NAME          = ${CMAKE_SYSTEM_NAME}"         )
message(STATUS "CMAKE_CXX_COMPILER_ID      = ${CMAKE_CXX_COMPILER_ID}"     )
message(STATUS "CMAKE_CXX_COMPILER_VERSION = ${CMAKE_CXX_COMPILER_VERSION}")
message(STATUS "CMAKE_COMPILER_IS_GNUCXX   = ${CMAKE_COMPILER_IS_GNUCXX}"  )


if(WIN32)
  message(STATUS "")
  message(STATUS "WARNING:")
  message(STATUS "Automatic installation is currently not available for this platform.")
  message(STATUS "Please use the manual installation, as described in the README.txt file.")
  message(STATUS "You can also use the 'include' folder directly, but you may want to edit")
  message(STATUS "'include/armadillo_bits/config.hpp' if you have LAPACK installed.")
  message(STATUS "")
endif()



##
## Find LAPACK and BLAS libraries, or their optimised versions
##

if(APPLE)
  
  set(ARMA_OS macos)
  
  set(ARMA_USE_LAPACK true)
  set(ARMA_USE_BLAS   true)
  
  set(ARMA_LIBS ${ARMA_LIBS} "-framework Accelerate")  # or "-framework accelerate" ?
  message(STATUS "MacOS X detected. Added '-framework Accelerate' to compiler flags")
  
  if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
    message(STATUS "Clang compiler on MacOS X detected. Added '-stdlib=libc++' to compiler flags")
  endif()
  
else()
  
  set(ARMA_OS unix)
  
  include(ARMA_FindMKL)
  include(ARMA_FindACMLMP)
  include(ARMA_FindACML)
  include(ARMA_FindOpenBLAS)
  include(ARMA_FindATLAS)
  include(ARMA_FindBLAS)
  include(ARMA_FindLAPACK)
  
  message(STATUS "     MKL_FOUND = ${MKL_FOUND}"     )
  message(STATUS "  ACMLMP_FOUND = ${ACMLMP_FOUND}"  )
  message(STATUS "    ACML_FOUND = ${ACML_FOUND}"    )
  message(STATUS "OpenBLAS_FOUND = ${OpenBLAS_FOUND}")
  message(STATUS "   ATLAS_FOUND = ${ATLAS_FOUND}"   )
  message(STATUS "    BLAS_FOUND = ${BLAS_FOUND}"    )
  message(STATUS "  LAPACK_FOUND = ${LAPACK_FOUND}"  )
  
  if(MKL_FOUND OR ACMLMP_FOUND OR ACML_FOUND)
    
    set(ARMA_USE_LAPACK true)
    set(ARMA_USE_BLAS   true)
    
    message(STATUS "")
    message(STATUS "*** If the MKL or ACML libraries are installed in non-standard locations such as")
    message(STATUS "*** /opt/intel/mkl, /opt/intel/composerxe/, /usr/local/intel/mkl")
    message(STATUS "*** make sure the run-time linker can find them.")
    message(STATUS "*** On Linux systems this can be done by editing /etc/ld.so.conf")
    message(STATUS "*** or modifying the LD_LIBRARY_PATH environment variable.")
    message(STATUS "")
    message(STATUS "*** On systems with SELinux enabled (eg. Fedora, RHEL),")
    message(STATUS "*** you may need to change the SELinux type of all MKL/ACML libraries")
    message(STATUS "*** to fix permission problems that may occur during run-time.")
    message(STATUS "*** See README.txt for more information")
    message(STATUS "")
    
    if(MKL_FOUND)
      set(ARMA_LIBS ${ARMA_LIBS} ${MKL_LIBRARIES})
      
      if(ACMLMP_FOUND OR ACML_FOUND)
        message(STATUS "*** Intel MKL as well as AMD ACML libraries were found.")
        message(STATUS "*** Using only the MKL library to avoid linking conflicts.")
        message(STATUS "*** If you wish to use ACML instead, please link manually with")
        message(STATUS "*** acml or acml_mp instead of the armadillo wrapper library.")
        message(STATUS "*** Alternatively, remove MKL from your system and rerun")
        message(STATUS "*** Armadillo's configuration using ./configure") 
      endif()
      
    else()
      
      if(ACMLMP_FOUND)
        set(ARMA_LIBS ${ARMA_LIBS} ${ACMLMP_LIBRARIES})
        
        message(STATUS "*** Both single-core and multi-core ACML libraries were found.")
        message(STATUS "*** Using only the multi-core library to avoid linking conflicts.")
      else()
        if(ACML_FOUND)
          set(ARMA_LIBS ${ARMA_LIBS} ${ACML_LIBRARIES})
        endif()
      endif()
      
    endif()
    
  else()
    
    if(OpenBLAS_FOUND AND ATLAS_FOUND)
      message(STATUS "")
      message(STATUS "*** WARNING: found both OpenBLAS and ATLAS; ATLAS will not be used")
    endif()
    
    if(OpenBLAS_FOUND AND BLAS_FOUND)
      message(STATUS "")
      message(STATUS "*** WARNING: found both OpenBLAS and BLAS; BLAS will not be used")
    endif()
    
    if(OpenBLAS_FOUND)
      
      set(ARMA_USE_BLAS true)
      set(ARMA_LIBS ${ARMA_LIBS} ${OpenBLAS_LIBRARIES})
      
      message(STATUS "")
      message(STATUS "*** If the OpenBLAS library is installed in")
      message(STATUS "*** /usr/local/lib or /usr/local/lib64")
      message(STATUS "*** make sure the run-time linker can find it.")
      message(STATUS "*** On Linux systems this can be done by editing /etc/ld.so.conf")
      message(STATUS "*** or modifying the LD_LIBRARY_PATH environment variable.")
      message(STATUS "")
      
    else()
      
      if(ATLAS_FOUND)
        set(ARMA_USE_ATLAS true)
        set(ARMA_ATLAS_INCLUDE_DIR ${ATLAS_INCLUDE_DIR})
        set(ARMA_LIBS ${ARMA_LIBS} ${ATLAS_LIBRARIES})
        
        message(STATUS "ATLAS_INCLUDE_DIR = ${ATLAS_INCLUDE_DIR}")
      endif()
      
      if(BLAS_FOUND)
        set(ARMA_USE_BLAS true)
        set(ARMA_LIBS ${ARMA_LIBS} ${BLAS_LIBRARIES})
      endif()
      
    endif()
    
    if(LAPACK_FOUND)
      set(ARMA_USE_LAPACK true)
      set(ARMA_LIBS ${ARMA_LIBS} ${LAPACK_LIBRARIES})
    endif()
      
  endif()
  
endif()


# set(DETECT_HDF5 true)

## uncomment the above line to enable the detection of the HDF5 library;
## you can also enable HDF5 detection directly on the command line:
## cmake -D DETECT_HDF5=true .

if(DETECT_HDF5)
  find_package(HDF5 QUIET)

  if(NOT HDF5_FOUND)
    # On Debian systems, the HDF5 package has been split into multiple packages
    # so that it is co-installable.  But this may mean that the include files
    # are hidden somewhere very odd that the FindHDF5.cmake script will not
    # find.  Thus, we'll also quickly check pkgconfig to see if there is
    # information on what to use there.
    find_package(PkgConfig)
    if (PKG_CONFIG_FOUND)
      pkg_check_modules(HDF5 hdf5)
      # But using pkgconfig is a little weird because HDF5_LIBRARIES won't be
      # filled with exact library paths, like the other scripts.  So instead
      # what we get is HDF5_LIBRARY_DIRS which is the equivalent of what we'd
      # pass to -L.  So we have to add those...
      if (HDF5_FOUND)
        link_directories("${HDF5_LIBRARY_DIRS}")
      endif()
    endif()
  endif()
 
  message(STATUS "HDF5_FOUND = ${HDF5_FOUND}")
  if(HDF5_FOUND)
    set(ARMA_USE_HDF5_ALT true)
    set(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${HDF5_INCLUDE_DIRS})
    set(ARMA_LIBS ${ARMA_LIBS} ${HDF5_LIBRARIES})
    # Since we called HDF5 with no arguments, the script will find only the C
    # bindings.  So HDF5_INCLUDE_DIRS may now contain one or two elements; if it
    # contains two, the first is what the user passed as HDF5_INCLUDE_DIR and we
    # should use that as ARMA_HDF5_INCLUDE_DIR.  Otherwise, the one entry in
    # HDF5_INCLUDE_DIRS is the correct include directory.  So, in either case we
    # can use the first element in the list.  Issue a status message, too, just
    # for good measure.
    list(GET HDF5_INCLUDE_DIRS 0 ARMA_HDF5_INCLUDE_DIR)
    message(STATUS "Set ARMA_HDF5_INCLUDE_DIR to ${ARMA_HDF5_INCLUDE_DIR}")
  endif()
endif()


include(ARMA_FindARPACK)
message(STATUS "ARPACK_FOUND = ${ARPACK_FOUND}")

if(ARPACK_FOUND)
  set(ARMA_USE_ARPACK true)
  set(ARMA_LIBS ${ARMA_LIBS} ${ARPACK_LIBRARY})
endif()

include(ARMA_FindSuperLU)
message(STATUS "SuperLU_FOUND = ${SuperLU_FOUND}")

if(SuperLU_FOUND)
  message(STATUS "SuperLU_INCLUDE_DIR = ${SuperLU_INCLUDE_DIR}")
  set(ARMA_USE_SUPERLU true)
  set(ARMA_LIBS ${ARMA_LIBS} ${SuperLU_LIBRARY})
  set(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${SuperLU_INCLUDE_DIR})
  set(ARMA_SUPERLU_INCLUDE_DIR ${SuperLU_INCLUDE_DIR})
endif()

message(STATUS "")
message(STATUS "*** Armadillo wrapper library will use the following libraries:")
message(STATUS "*** ARMA_LIBS = ${ARMA_LIBS}")
message(STATUS "")


if(DEFINED CMAKE_CXX_COMPILER_ID AND DEFINED CMAKE_CXX_COMPILER_VERSION)
  if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND NOT ${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 4.8.3)
    set(ARMA_USE_EXTERN_CXX11_RNG true)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
    message(STATUS "Detected gcc 4.8.3 or later. Added '-std=c++11' to compiler flags")
  endif()
endif()


message(STATUS "Copying ${PROJECT_SOURCE_DIR}/include/ to ${PROJECT_BINARY_DIR}/tmp/include/")
file(COPY ${PROJECT_SOURCE_DIR}/include/ DESTINATION ${PROJECT_BINARY_DIR}/tmp/include/)

message(STATUS "Generating ${PROJECT_BINARY_DIR}/tmp/include/config.hpp")
configure_file(${PROJECT_BINARY_DIR}/tmp/include/armadillo_bits/config.hpp.cmake ${PROJECT_BINARY_DIR}/tmp/include/armadillo_bits/config.hpp)

message(STATUS "Generating ${PROJECT_SOURCE_DIR}/examples/Makefile")
configure_file(${PROJECT_SOURCE_DIR}/examples/Makefile.cmake ${PROJECT_SOURCE_DIR}/examples/Makefile)


include_directories(${PROJECT_BINARY_DIR}/tmp/include/ ${CMAKE_REQUIRED_INCLUDES})


## work around a silly limitation in Mac OS X
if(APPLE)
  if(${ARMA_MINOR} GREATER 99)
    math(EXPR ARMA_MINOR_ALT "${ARMA_MINOR} / 10")
  else()
    set(ARMA_MINOR_ALT ${ARMA_MINOR})
  endif()
else()
  set(ARMA_MINOR_ALT ${ARMA_MINOR})
endif()


## necessary when linking with Intel MKL on Linux systems
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-as-needed")
endif()


if(CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2")
endif()

message(STATUS "CMAKE_CXX_FLAGS           = ${CMAKE_CXX_FLAGS}"          )
message(STATUS "CMAKE_SHARED_LINKER_FLAGS = ${CMAKE_SHARED_LINKER_FLAGS}")
message(STATUS "CMAKE_REQUIRED_INCLUDES   = ${CMAKE_REQUIRED_INCLUDES}"  )

add_library( armadillo ${PROJECT_SOURCE_DIR}/src/wrapper.cpp )
target_link_libraries( armadillo ${ARMA_LIBS} )
set_target_properties(armadillo PROPERTIES VERSION ${ARMA_MAJOR}.${ARMA_MINOR_ALT}.${ARMA_PATCH} SOVERSION ${ARMA_MAJOR})


################################################################################

## armadillo 7.600.2+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 
-# Copyright (C) 2008-2015 National ICT Australia (NICTA)
+# Copyright (C) 2008-2016 National ICT Australia (NICTA)
 # 
 # This Source Code Form is subject to the terms of the Mozilla Public
 # License, v. 2.0. If a copy of the MPL was not distributed with this
@@ -14,13 +14,9 @@
 
 cmake_minimum_required(VERSION 2.8 FATAL_ERROR)
 
-set(ARMA_MAJOR 6)
-set(ARMA_MINOR 500)
-set(ARMA_PATCH 5)
-set(ARMADILLO_VERSION ${ARMA_MAJOR}.${ARMA_MINOR}.${ARMA_PATCH})
-
-message(STATUS "Configuring Armadillo ${ARMADILLO_VERSION}")
-
+project(armadillo CXX)
+include(CheckIncludeFileCXX)
+include(CheckLibraryExists)
 
 ## Set ARMA_USE_WRAPPER to false if you're getting linking errors when compiling your programs,
 ## or if you prefer to directly link with BLAS and/or LAPACK.
@@ -38,34 +34,62 @@
 set(ARMA_USE_HDF5_ALT         false)
 set(ARMA_USE_ARPACK           false)
 set(ARMA_USE_EXTERN_CXX11_RNG false)
-set(ARMA_USE_SUPERLU          false)  # Caveat: only SuperLU version 4.3 can be used!
-
-project(armadillo CXX)
+set(ARMA_USE_SUPERLU          false)  # Caveat: only SuperLU version 5.x can be used!
+
+
+## extract version from sources
+
+set(ARMA_VERSION_FILE_NAME "${PROJECT_SOURCE_DIR}/include/armadillo_bits/arma_version.hpp")
+
+if(NOT EXISTS ${ARMA_VERSION_FILE_NAME})
+  message(FATAL_ERROR "Can't read ${ARMA_VERSION_FILE_NAME}")
+endif()
+
+file(READ ${ARMA_VERSION_FILE_NAME} ARMA_VERSION_FILE_CONTENTS)
+string(REGEX REPLACE ".*#define ARMA_VERSION_MAJOR ([0-9]+).*" "\\1" ARMA_VERSION_MAJOR "${ARMA_VERSION_FILE_CONTENTS}")
+string(REGEX REPLACE ".*#define ARMA_VERSION_MINOR ([0-9]+).*" "\\1" ARMA_VERSION_MINOR "${ARMA_VERSION_FILE_CONTENTS}")
+string(REGEX REPLACE ".*#define ARMA_VERSION_PATCH ([0-9]+).*" "\\1" ARMA_VERSION_PATCH "${ARMA_VERSION_FILE_CONTENTS}")
+
+message(STATUS "Configuring Armadillo ${ARMA_VERSION_MAJOR}.${ARMA_VERSION_MINOR}.${ARMA_VERSION_PATCH}")
+
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake_aux/Modules/")
 
-include(CheckIncludeFileCXX)
-include(CheckLibraryExists)
-
-option(BUILD_SHARED_LIBS "build shared library" ON)
+
+if(MSVC)
+  option(BUILD_SHARED_LIBS "build shared library" OFF)
+else()
+  option(BUILD_SHARED_LIBS "build shared library" ON)
+endif()
+
+option(DETECT_PKG_CONFIG "Detect pkg-config and install pkg-config data, if found" ON)
+
 option(DETECT_HDF5 "Detect HDF5 and include HDF5 support, if found" OFF)
+
+
+if(WIN32)
+  message(STATUS "")
+  message(STATUS "*** WARNING: automatic installation is experimental for this platform.")
+  message(STATUS "*** WARNING: if anything breaks, you get to keep all the pieces.")
+  message(STATUS "*** WARNING: manual installation is described in README.txt")
+  message(STATUS "")
+endif()
+
+if(MSVC AND BUILD_SHARED_LIBS)
+  message(STATUS "")
+  message(STATUS "*** WARNING: building shared library with MSVC is not supported." )
+  message(STATUS "*** WARNING: if anything breaks, you get to keep all the pieces.")
+  message(STATUS "")
+endif()
+
 
 message(STATUS "CMAKE_SYSTEM_NAME          = ${CMAKE_SYSTEM_NAME}"         )
 message(STATUS "CMAKE_CXX_COMPILER_ID      = ${CMAKE_CXX_COMPILER_ID}"     )
 message(STATUS "CMAKE_CXX_COMPILER_VERSION = ${CMAKE_CXX_COMPILER_VERSION}")
 message(STATUS "CMAKE_COMPILER_IS_GNUCXX   = ${CMAKE_COMPILER_IS_GNUCXX}"  )
-
-
-if(WIN32)
-  message(STATUS "")
-  message(STATUS "WARNING:")
-  message(STATUS "Automatic installation is currently not available for this platform.")
-  message(STATUS "Please use the manual installation, as described in the README.txt file.")
-  message(STATUS "You can also use the 'include' folder directly, but you may want to edit")
-  message(STATUS "'include/armadillo_bits/config.hpp' if you have LAPACK installed.")
-  message(STATUS "")
-endif()
-
+message(STATUS "BUILD_SHARED_LIBS          = ${BUILD_SHARED_LIBS}"         )
+message(STATUS "DETECT_PKG_CONFIG          = ${DETECT_PKG_CONFIG}"         )
+message(STATUS "DETECT_HDF5                = ${DETECT_HDF5}"               )
 
 
 ##
@@ -204,6 +228,11 @@
 endif()
 
 
+if(DETECT_PKG_CONFIG)
+  find_package(PkgConfig)
+endif()
+
+
 # set(DETECT_HDF5 true)
 
 ## uncomment the above line to enable the detection of the HDF5 library;
@@ -219,7 +248,6 @@
     # are hidden somewhere very odd that the FindHDF5.cmake script will not
     # find.  Thus, we'll also quickly check pkgconfig to see if there is
     # information on what to use there.
-    find_package(PkgConfig)
     if (PKG_CONFIG_FOUND)
       pkg_check_modules(HDF5 hdf5)
       # But using pkgconfig is a little weird because HDF5_LIBRARIES won't be
@@ -249,7 +277,6 @@
   endif()
 endif()
 
-
 include(ARMA_FindARPACK)
 message(STATUS "ARPACK_FOUND = ${ARPACK_FOUND}")
 
@@ -258,7 +285,7 @@
   set(ARMA_LIBS ${ARMA_LIBS} ${ARPACK_LIBRARY})
 endif()
 
-include(ARMA_FindSuperLU)
+include(ARMA_FindSuperLU5)
 message(STATUS "SuperLU_FOUND = ${SuperLU_FOUND}")
 
 if(SuperLU_FOUND)
@@ -294,38 +321,3 @@
 configure_file(${PROJECT_SOURCE_DIR}/examples/Makefile.cmake ${PROJECT_SOURCE_DIR}/examples/Makefile)
 
 
-include_directories(${PROJECT_BINARY_DIR}/tmp/include/ ${CMAKE_REQUIRED_INCLUDES})
-
-
-## work around a silly limitation in Mac OS X
-if(APPLE)
-  if(${ARMA_MINOR} GREATER 99)
-    math(EXPR ARMA_MINOR_ALT "${ARMA_MINOR} / 10")
-  else()
-    set(ARMA_MINOR_ALT ${ARMA_MINOR})
-  endif()
-else()
-  set(ARMA_MINOR_ALT ${ARMA_MINOR})
-endif()
-
-
-## necessary when linking with Intel MKL on Linux systems
-if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
-  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-as-needed")
-endif()
-
-
-if(CMAKE_COMPILER_IS_GNUCXX)
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2")
-endif()
-
-message(STATUS "CMAKE_CXX_FLAGS           = ${CMAKE_CXX_FLAGS}"          )
-message(STATUS "CMAKE_SHARED_LINKER_FLAGS = ${CMAKE_SHARED_LINKER_FLAGS}")
-message(STATUS "CMAKE_REQUIRED_INCLUDES   = ${CMAKE_REQUIRED_INCLUDES}"  )
-
-add_library( armadillo ${PROJECT_SOURCE_DIR}/src/wrapper.cpp )
-target_link_libraries( armadillo ${ARMA_LIBS} )
-set_target_properties(armadillo PROPERTIES VERSION ${ARMA_MAJOR}.${ARMA_MINOR_ALT}.${ARMA_PATCH} SOVERSION ${ARMA_MAJOR})
-
-
-################################################################################

=== tests/Makefile ===

LIB_FLAGS = -larmadillo
#LIB_FLAGS = -lblas -llapack 
#LIB_FLAGS = -lopenblas -llapack 

CXX_FLAGS = -std=c++11 -Wshadow -Wall -pedantic -O0
#CXX_FLAGS = -std=c++11 -Wshadow -Wall -pedantic -O0 -DARMA_DONT_USE_WRAPPER
#CXX_FLAGS = -std=c++11 -Wshadow -Wall -pedantic -O2

OBJECTS = $(patsubst %.cpp,%.o,$(wildcard *.cpp))

%.o: %.cpp $(DEPS)
	$(CXX) $(CXX_FLAGS) -o $@ -c $< $

main: $(OBJECTS)
	$(CXX) $(CXX_FLAGS) -o $@ $(OBJECTS) $(LIB_FLAGS)


all: main

.PHONY: clean

clean:
	rm -f main *.o

=== debian/changelog ===
armadillo (1:7.600.2+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Sat, 24 Dec 2016 21:19:03 +0530

armadillo (1:7.500.2+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Tue, 29 Nov 2016 18:40:29 +0530

armadillo (1:7.500.1+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Tue, 15 Nov 2016 06:02:42 +0530

armadillo (1:7.500.0+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Update watch file
  * Update copyright file

 -- Kumar Appaiah <akumar@debian.org>  Wed, 26 Oct 2016 20:47:35 +0530

armadillo (1:7.400.2+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Update watch file to use SF magic URL

 -- Kumar Appaiah <akumar@debian.org>  Sat, 24 Sep 2016 17:07:31 +0530

armadillo (1:7.400.1+dfsg-2) unstable; urgency=medium

  * Upload to unstable
  * Works with superlu 5 (Closes: #837152)

 -- Kumar Appaiah <akumar@debian.org>  Fri, 09 Sep 2016 20:56:23 +0530

armadillo (1:7.400.1+dfsg-1) experimental; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Wed, 17 Aug 2016 16:07:37 +0530

armadillo (1:7.200.2+dfsg-1) experimental; urgency=medium

  * New upstream release
  * Update superlu dependency to 5.2 or more
  * Switch to dpkg-source 3.0 (quilt) format
  * Standards version is now 3.9.8 (no changes needed)
  * The new package (with soname) is libarmadillo7
  * Convert to 3.0 (quilt)

 -- Kumar Appaiah <akumar@debian.org>  Tue, 05 Jul 2016 10:50:51 +0530

armadillo (1:6.700.6+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Wed, 04 May 2016 07:11:13 +0530

armadillo (1:6.700.3+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Standards version is now 3.6.7 (no changes required)

 -- Kumar Appaiah <akumar@debian.org>  Sun, 10 Apr 2016 18:17:04 +0530

armadillo (1:6.500.5+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Alter dfsg-repack.sh to ignore .mat files

 -- Kumar Appaiah <akumar@debian.org>  Mon, 15 Feb 2016 21:02:28 +0530

armadillo (1:6.400.3+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Wed, 23 Dec 2015 16:45:14 +0530

armadillo (1:6.200.4+dfsg-1) unstable; urgency=medium

  * New upstream release
  * debian/copyright updated to reflect correct copyright assignment.

 -- Kumar Appaiah <akumar@debian.org>  Tue, 17 Nov 2015 18:15:06 +0530

armadillo (1:6.100.0+dfsg-2) unstable; urgency=medium

  * Upload to unstable

 -- Kumar Appaiah <akumar@debian.org>  Sun, 11 Oct 2015 07:16:19 +0530

armadillo (1:6.100.0+dfsg-1) experimental; urgency=medium

  * New upstream release
  * The new package (with soname) is libarmadillo6

 -- Kumar Appaiah <akumar@debian.org>  Mon, 05 Oct 2015 21:24:27 +0530

armadillo (1:5.500.2+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Fri, 04 Sep 2015 12:04:31 +0530

armadillo (1:5.400.2+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Mon, 24 Aug 2015 20:03:56 +0530

armadillo (1:5.200.1+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Sat, 13 Jun 2015 16:17:23 +0530

armadillo (1:5.100.2+dfsg-5) unstable; urgency=medium

  * Remove extraneous Proxy.hpp patch

 -- Kumar Appaiah <akumar@debian.org>  Tue, 26 May 2015 08:43:29 +0530

armadillo (1:5.100.2+dfsg-4) unstable; urgency=medium

  * libarmadillo-dev depends on libsuperlu-dev

 -- Kumar Appaiah <akumar@debian.org>  Sat, 23 May 2015 14:40:49 +0530

armadillo (1:5.100.2+dfsg-3) unstable; urgency=medium

  * Upload to unstable.

 -- Kumar Appaiah <akumar@debian.org>  Thu, 21 May 2015 18:33:04 +0530

armadillo (1:5.100.2+dfsg-2) experimental; urgency=medium

  * Add libsuperlu dependency

 -- Kumar Appaiah <akumar@debian.org>  Tue, 19 May 2015 11:30:01 +0530

armadillo (1:5.100.2+dfsg-1) experimental; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Sat, 16 May 2015 20:27:43 +0530

armadillo (1:5.000.1+dfsg-1) experimental; urgency=medium

  * New upstream release
  * The new package (with soname) is libarmadillo5
  * Standards version is now 3.9.6 (no changes)

 -- Kumar Appaiah <akumar@debian.org>  Sat, 18 Apr 2015 06:06:13 +0530

armadillo (1:4.550.2+dfsg-1) experimental; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Fri, 05 Dec 2014 19:26:06 +0530

armadillo (1:4.450.4+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Mon, 27 Oct 2014 20:06:26 +0530

armadillo (1:4.450.2+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Sat, 04 Oct 2014 09:31:39 +0530

armadillo (1:4.400.2+dfsg-2) unstable; urgency=medium

  * Remove hdf5 build dependency

 -- Kumar Appaiah <akumar@debian.org>  Mon, 08 Sep 2014 15:43:44 +0530

armadillo (1:4.400.2+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Depend on dpkg-dev 1.16.1 or higher and use buildflags.mk instead of
    hardening-wrapper.

 -- Kumar Appaiah <akumar@debian.org>  Sat, 06 Sep 2014 15:41:57 +0530

armadillo (1:4.320.0+dfsg-1) unstable; urgency=medium

  * New upstream releasep

 -- Kumar Appaiah <akumar@debian.org>  Fri, 11 Jul 2014 16:14:15 +0530

armadillo (1:4.300.8+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Thu, 05 Jun 2014 00:32:53 -0400

armadillo (1:4.300.0+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Depend on libhdf5-dev dor upstream changes

 -- Kumar Appaiah <akumar@debian.org>  Mon, 05 May 2014 22:52:03 -0400

armadillo (1:4.200.0+dfsg-1) unstable; urgency=medium

  * Update SCM URIs to canonical ones
  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Mon, 07 Apr 2014 20:25:16 -0400



=== debian/control ===
Source: armadillo
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Kumar Appaiah <akumar@debian.org>
Build-Depends: debhelper (>= 7), libblas-dev, liblapack-dev, cmake, libarpack2-dev, dpkg-dev (>= 1.16.1~), libsuperlu-dev (>= 5.2)
Standards-Version: 3.9.8
Section: libs
Homepage: http://arma.sourceforge.net/
Vcs-Git: git://anonscm.debian.org/debian-science/packages/armadillo.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/armadillo.git

Package: libarmadillo-dev
Section: libdevel
Architecture: any
Suggests: libitpp-dev
Depends: libarmadillo7 (= ${binary:Version}), ${misc:Depends}, libarpack2-dev, libhdf5-dev, libsuperlu-dev (>= 5.2)
Replaces: libarmadillo-doc (<= 1.1.2-1)
Conflicts: libarmadillo-doc
Description: streamlined C++ linear algebra library - Headers
 Armadillo is a streamlined C++ linear algebra library (matrix maths)
 aiming towards a good balance between speed and ease of use. Integer,
 floating point and complex numbers are supported, as well as a subset
 of trigonometric and statistics functions. Optional integration with
 LAPACK and ATLAS libraries is also provided.
 .
 This package has the development libraries and headers for Armadillo.

Package: libarmadillo7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: streamlined C++ linear algebra library
 Armadillo is a streamlined C++ linear algebra library (matrix maths)
 aiming towards a good balance between speed and ease of use. Integer,
 floating point and complex numbers are supported, as well as a subset
 of trigonometric and statistics functions. Optional integration with
 LAPACK and ATLAS libraries is also provided.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
CROSS= --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
else
CROSS= --build $(DEB_BUILD_GNU_TYPE)
endif

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp:
	dh_testdir
	cmake -DCMAKE_VERBOSE_MAKEFILE=ON -D INSTALL_LIB_DIR=lib -D CMAKE_INpppSTALL_PREFIX_INITIALIZED_TO_DEFAULT:BOOL=ON  . # specified to install to the debian/tmp directory.
	$(MAKE)
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	rm -rf debian/doc_gen
	[ ! -f Makefile ] || $(MAKE) clean
	rm -f config.guess config.sub Makefile
	rm -f CMakeCache.txt cmake_install.cmake
	rm -rf CMakeFiles
	rm -f install_manifest.txt include/armadillo_bits/config.hpp examples/Makefile
	rm -f ArmadilloConfig.cmake ArmadilloConfigVersion.cmake 
	rm -rf InstallFiles
	dh_clean  --exclude ./src/include/armadillo_bits/dgemm_proto.hpp.orig

install: build
	dh_testdir
	dh_testroot
	dh_prep --exclude ./src/include/armadillo_bits/dgemm_proto.hpp.orig
	dh_installdirs
	$(MAKE) prefix=$(CURDIR)/debian/tmp/usr install DESTDIR=debian/tmp

binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_installchangelogs -a
	dh_installdocs -a
	dh_installexamples -a
	dh_install -a --sourcedir=debian/tmp
	dh_installman -a
	dh_link -a
	dh_strip -a
	dh_compress -a -X.cpp
	dh_fixperms -a
	dh_makeshlibs -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary-indep: build install
# Currently no arch-independent packages

binary: binary-indep binary-arch
.PHONY: build clean binary-arch binary install

## armadillo 7.960.1+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,20 +1,24 @@
 
-# Copyright (C) 2008-2016 National ICT Australia (NICTA)
+# Copyright 2008-2016 Conrad Sanderson (http://conradsanderson.id.au)
+# Copyright 2008-2016 National ICT Australia (NICTA)
 # 
-# This Source Code Form is subject to the terms of the Mozilla Public
-# License, v. 2.0. If a copy of the MPL was not distributed with this
-# file, You can obtain one at http://mozilla.org/MPL/2.0/.
-# -------------------------------------------------------------------
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+# http://www.apache.org/licenses/LICENSE-2.0
 # 
-# Written by Conrad Sanderson - http://conradsanderson.id.au
-# Written by Ryan Curtin
-# Written by Clement Creusot
-
-
-
-cmake_minimum_required(VERSION 2.8 FATAL_ERROR)
-
-project(armadillo CXX)
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+# ------------------------------------------------------------------------
+
+
+
+cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)
+
+project(armadillo CXX C)
 include(CheckIncludeFileCXX)
 include(CheckLibraryExists)
 
@@ -36,6 +40,17 @@
 set(ARMA_USE_EXTERN_CXX11_RNG false)
 set(ARMA_USE_SUPERLU          false)  # Caveat: only SuperLU version 5.x can be used!
 
+## NOTE: OpenBLAS appears to have its own LAPACK functions,
+## NOTE: but on some systems the installed version of OpenBLAS
+## NOTE: has been modified not to include LAPACK functions.
+## NOTE: As the presence of LAPACK functions in OpenBLAS can't be guaranteed,
+## NOTE: this installer script requires LAPACK to be present on the system
+## NOTE: in order to enable the use of LAPACK functions by Armadillo.
+## NOTE: This installer will link with OpenBLAS first,
+## NOTE: so if a full version of OpenBLAS is actually present on the system,
+## NOTE: the linker should make use of LAPACK functions from OpenBLAS
+## NOTE: instead of standard LAPACK.
+
 
 ## extract version from sources
 
@@ -53,7 +68,49 @@
 message(STATUS "Configuring Armadillo ${ARMA_VERSION_MAJOR}.${ARMA_VERSION_MINOR}.${ARMA_VERSION_PATCH}")
 
 
-set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake_aux/Modules/")
+# As Red Hat Enterprise Linux (and related systems such as Fedora)
+# does not search /usr/local/lib by default, we need to place the
+# library in either /usr/lib or /usr/lib64
+
+if(NOT APPLE)
+  if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
+    message(STATUS "*** CMAKE_INSTALL_PREFIX was initalised by cmake to the default value of ${CMAKE_INSTALL_PREFIX}")
+    message(STATUS "*** CMAKE_INSTALL_PREFIX changed to /usr")
+    set(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "Standard install prefix" FORCE)
+  endif()
+endif()
+
+
+# Adhere to GNU filesystem layout conventions
+include(GNUInstallDirs)
+
+# deprecated options
+set(INSTALL_LIB_DIR     "" CACHE STRING "deprecated; use CMAKE_INSTALL_LIBDIR instead")
+set(INSTALL_INCLUDE_DIR "" CACHE STRING "deprecated; use CMAKE_INSTALL_INCLUDEDIR instead")
+set(INSTALL_DATA_DIR    "" CACHE STRING "deprecated; use CMAKE_INSTALL_DATADIR instead")
+set(INSTALL_BIN_DIR     "" CACHE STRING "deprecated; use CMAKE_INSTALL_BINDIR instead")
+
+if(INSTALL_LIB_DIR)
+  message(STATUS "*** INSTALL_LIB_DIR is deprecated; use CMAKE_INSTALL_LIBDIR instead")
+  set(CMAKE_INSTALL_LIBDIR "${INSTALL_LIB_DIR}")
+  GNUInstallDirs_get_absolute_install_dir(CMAKE_INSTALL_FULL_LIBDIR CMAKE_INSTALL_LIBDIR)
+endif()
+
+if(INSTALL_INCLUDE_DIR)
+  message(STATUS "*** INSTALL_INCLUDE_DIR is deprecated; use CMAKE_INSTALL_INCLUDEDIR instead")
+  set(CMAKE_INSTALL_INCLUDEDIR "${INSTALL_INCLUDE_DIR}")
+  GNUInstallDirs_get_absolute_install_dir(CMAKE_INSTALL_FULL_INCLUDEDIR CMAKE_INSTALL_INCLUDEDIR)
+endif()
+
+if(INSTALL_DATA_DIR)
+  message(STATUS "*** INSTALL_DATA_DIR is deprecated; use CMAKE_INSTALL_DATADIR instead")
+  set(CMAKE_INSTALL_DATADIR "${INSTALL_DATA_DIR}")
+endif()
+
+if(INSTALL_BIN_DIR)
+  message(STATUS "*** INSTALL_BIN_DIR is deprecated; use CMAKE_INSTALL_BINDIR instead")
+  set(CMAKE_INSTALL_BINDIR "${INSTALL_BIN_DIR}")
+endif()
 
 
 if(MSVC)
@@ -61,8 +118,6 @@
 else()
   option(BUILD_SHARED_LIBS "build shared library" ON)
 endif()
-
-option(DETECT_PKG_CONFIG "Detect pkg-config and install pkg-config data, if found" ON)
 
 option(DETECT_HDF5 "Detect HDF5 and include HDF5 support, if found" OFF)
 
@@ -88,13 +143,14 @@
 message(STATUS "CMAKE_CXX_COMPILER_VERSION = ${CMAKE_CXX_COMPILER_VERSION}")
 message(STATUS "CMAKE_COMPILER_IS_GNUCXX   = ${CMAKE_COMPILER_IS_GNUCXX}"  )
 message(STATUS "BUILD_SHARED_LIBS          = ${BUILD_SHARED_LIBS}"         )
-message(STATUS "DETECT_PKG_CONFIG          = ${DETECT_PKG_CONFIG}"         )
 message(STATUS "DETECT_HDF5                = ${DETECT_HDF5}"               )
 
 
 ##
 ## Find LAPACK and BLAS libraries, or their optimised versions
 ##
+
+set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake_aux/Modules/")
 
 if(APPLE)
   
@@ -228,9 +284,7 @@
 endif()
 
 
-if(DETECT_PKG_CONFIG)
-  find_package(PkgConfig)
-endif()
+find_package(PkgConfig)
 
 
 # set(DETECT_HDF5 true)
@@ -240,7 +294,7 @@
 ## cmake -D DETECT_HDF5=true .
 
 if(DETECT_HDF5)
-  find_package(HDF5 QUIET)
+  find_package(HDF5 QUIET COMPONENTS C)
 
   if(NOT HDF5_FOUND)
     # On Debian systems, the HDF5 package has been split into multiple packages
@@ -257,67 +311,3 @@
       if (HDF5_FOUND)
         link_directories("${HDF5_LIBRARY_DIRS}")
       endif()
-    endif()
-  endif()
- 
-  message(STATUS "HDF5_FOUND = ${HDF5_FOUND}")
-  if(HDF5_FOUND)
-    set(ARMA_USE_HDF5_ALT true)
-    set(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${HDF5_INCLUDE_DIRS})
-    set(ARMA_LIBS ${ARMA_LIBS} ${HDF5_LIBRARIES})
-    # Since we called HDF5 with no arguments, the script will find only the C
-    # bindings.  So HDF5_INCLUDE_DIRS may now contain one or two elements; if it
-    # contains two, the first is what the user passed as HDF5_INCLUDE_DIR and we
-    # should use that as ARMA_HDF5_INCLUDE_DIR.  Otherwise, the one entry in
-    # HDF5_INCLUDE_DIRS is the correct include directory.  So, in either case we
-    # can use the first element in the list.  Issue a status message, too, just
-    # for good measure.
-    list(GET HDF5_INCLUDE_DIRS 0 ARMA_HDF5_INCLUDE_DIR)
-    message(STATUS "Set ARMA_HDF5_INCLUDE_DIR to ${ARMA_HDF5_INCLUDE_DIR}")
-  endif()
-endif()
-
-include(ARMA_FindARPACK)
-message(STATUS "ARPACK_FOUND = ${ARPACK_FOUND}")
-
-if(ARPACK_FOUND)
-  set(ARMA_USE_ARPACK true)
-  set(ARMA_LIBS ${ARMA_LIBS} ${ARPACK_LIBRARY})
-endif()
-
-include(ARMA_FindSuperLU5)
-message(STATUS "SuperLU_FOUND = ${SuperLU_FOUND}")
-
-if(SuperLU_FOUND)
-  message(STATUS "SuperLU_INCLUDE_DIR = ${SuperLU_INCLUDE_DIR}")
-  set(ARMA_USE_SUPERLU true)
-  set(ARMA_LIBS ${ARMA_LIBS} ${SuperLU_LIBRARY})
-  set(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${SuperLU_INCLUDE_DIR})
-  set(ARMA_SUPERLU_INCLUDE_DIR ${SuperLU_INCLUDE_DIR})
-endif()
-
-message(STATUS "")
-message(STATUS "*** Armadillo wrapper library will use the following libraries:")
-message(STATUS "*** ARMA_LIBS = ${ARMA_LIBS}")
-message(STATUS "")
-
-
-if(DEFINED CMAKE_CXX_COMPILER_ID AND DEFINED CMAKE_CXX_COMPILER_VERSION)
-  if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND NOT ${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 4.8.3)
-    set(ARMA_USE_EXTERN_CXX11_RNG true)
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
-    message(STATUS "Detected gcc 4.8.3 or later. Added '-std=c++11' to compiler flags")
-  endif()
-endif()
-
-
-message(STATUS "Copying ${PROJECT_SOURCE_DIR}/include/ to ${PROJECT_BINARY_DIR}/tmp/include/")
-file(COPY ${PROJECT_SOURCE_DIR}/include/ DESTINATION ${PROJECT_BINARY_DIR}/tmp/include/)
-
-message(STATUS "Generating ${PROJECT_BINARY_DIR}/tmp/include/config.hpp")
-configure_file(${PROJECT_BINARY_DIR}/tmp/include/armadillo_bits/config.hpp.cmake ${PROJECT_BINARY_DIR}/tmp/include/armadillo_bits/config.hpp)
-
-message(STATUS "Generating ${PROJECT_SOURCE_DIR}/examples/Makefile")
-configure_file(${PROJECT_SOURCE_DIR}/examples/Makefile.cmake ${PROJECT_SOURCE_DIR}/examples/Makefile)
-
-

=== debian/changelog ===
armadillo (1:7.960.1+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Wed, 23 Aug 2017 22:38:28 +0530

armadillo (1:7.950.1+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Tue, 20 Jun 2017 20:36:34 +0530

armadillo (1:7.900.1+dfsg-2) experimental; urgency=medium

  * Update copyright to reflect Apache License

 -- Kumar Appaiah <akumar@debian.org>  Tue, 16 May 2017 07:08:51 +0530

armadillo (1:7.900.1+dfsg-1) experimental; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Mon, 15 May 2017 20:42:34 +0530

armadillo (1:7.600.2+dfsg-2) unstable; urgency=medium

  * Add patch for conv_alias from upstream

 -- Kumar Appaiah <akumar@debian.org>  Sun, 19 Feb 2017 12:24:41 +0530

## armadillo 8.400.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -119,7 +119,7 @@
   option(BUILD_SHARED_LIBS "build shared library" ON)
 endif()
 
-option(DETECT_HDF5 "Detect HDF5 and include HDF5 support, if found" OFF)
+option(DETECT_HDF5 "Detect HDF5 and include HDF5 support, if found" ON)
 
 
 if(WIN32)
@@ -166,6 +166,8 @@
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
     message(STATUS "Clang compiler on MacOS X detected. Added '-stdlib=libc++' to compiler flags")
   endif()
+  
+  set(CMAKE_MACOSX_RPATH 1)
   
 else()
   
@@ -287,11 +289,11 @@
 find_package(PkgConfig)
 
 
-# set(DETECT_HDF5 true)
-
-## uncomment the above line to enable the detection of the HDF5 library;
-## you can also enable HDF5 detection directly on the command line:
-## cmake -D DETECT_HDF5=true .
+# set(DETECT_HDF5 false)
+
+## uncomment the above line to disable the detection of the HDF5 library;
+## you can also disable HDF5 detection directly on the command line:
+## cmake -D DETECT_HDF5=false .
 
 if(DETECT_HDF5)
   find_package(HDF5 QUIET COMPONENTS C)
@@ -309,5 +311,3 @@
       # what we get is HDF5_LIBRARY_DIRS which is the equivalent of what we'd
       # pass to -L.  So we have to add those...
       if (HDF5_FOUND)
-        link_directories("${HDF5_LIBRARY_DIRS}")
-      endif()

=== examples/Makefile ===
# You may need to edit this file to reflect the type and capabilities of your system.
# The defaults are for a Linux system and may need to be changed for other systems (eg. Mac OS X).


CXX=g++

#CXX=CC
## When using the Sun Studio compiler


ARMA_INCLUDE_FLAG = -I ../include
## If you've installed Armadillo's headers manually, you may need to tell the compiler where they are.
## For example, change ../include to /usr/local/include


LIB_FLAGS = -lblas -llapack 
#LIB_FLAGS = -lopenblas -llapack 
#LIB_FLAGS = -framework Accelerate
#LIB_FLAGS = -library=sunperf

## NOTE: on Ubuntu and Debian based systems you may need to add -lgfortran to LIB_FLAGS
## NOTE: if you're using Mac OS, use the line with -framework Accelerate 
## NOTE: if you're using the Sun Studio compiler, use the line with -library=sunperf


OPT = -O2
## As the Armadillo library uses recursive templates, compilation times depend on the level of optimisation:
##
## -O0: quick compilation, but the resulting program will be slow
## -O1: good trade-off between compilation time and execution speed
## -O2: produces programs which have almost all possible speedups, but compilation takes longer
## -O3: enables auto vectorisation when using gcc

#OPT = -xO4 -xannotate=no
## When using the Sun Studio compiler


#EXTRA_OPT = -fwhole-program
## Uncomment the above line if you're compiling all source files into one program in a single hit


#DEBUG = -DARMA_EXTRA_DEBUG
## Uncomment the above line to enable low-level debugging.
## Lots of debugging information will be printed when a compiled program is run.
## Please enable this option when reporting bugs.


#FINAL = -DARMA_NO_DEBUG
## Uncomment the above line to disable Armadillo's checks.
## Not recommended unless your code has been first thoroughly tested!


CXXFLAGS = $(ARMA_INCLUDE_FLAG) $(DEBUG) $(FINAL) $(OPT) $(EXTRA_OPT) 

all: example1

example1: example1.cpp
	$(CXX) $(CXXFLAGS)  -o $@  $<  $(LIB_FLAGS)


.PHONY: clean

clean:
	rm -f example1

=== tests/Makefile ===
--- 
+++ 
@@ -4,13 +4,14 @@
 #LIB_FLAGS = -lopenblas -llapack 
 
 CXX_FLAGS = -std=c++11 -Wshadow -Wall -pedantic -O0
+#CXX_FLAGS = -std=c++11 -Wshadow -Wall -pedantic -O0 -fopenmp
 #CXX_FLAGS = -std=c++11 -Wshadow -Wall -pedantic -O0 -DARMA_DONT_USE_WRAPPER
 #CXX_FLAGS = -std=c++11 -Wshadow -Wall -pedantic -O2
 
 OBJECTS = $(patsubst %.cpp,%.o,$(wildcard *.cpp))
 
 %.o: %.cpp $(DEPS)
-	$(CXX) $(CXX_FLAGS) -o $@ -c $< $
+	$(CXX) $(CXX_FLAGS) -o $@ -c $<
 
 main: $(OBJECTS)
 	$(CXX) $(CXX_FLAGS) -o $@ $(OBJECTS) $(LIB_FLAGS)

=== debian/changelog ===
armadillo (1:8.400.0+dfsg-2) unstable; urgency=medium

  * Fix debian/rules to allow armadillo to build from source. Patch from
    Helmut Grohne. (Closes: #875405)
  * Add -V to dh_makeshlibs to obtain versioned dependencies. (Closes: #885971)
  * debhelper compay 9 automagically produces debug symbols.. (Closes: #744048)

 -- Kumar Appaiah <akumar@debian.org>  Wed, 21 Feb 2018 06:04:02 +0530

armadillo (1:8.400.0+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Tue, 20 Feb 2018 19:48:07 +0530

armadillo (1:8.300.3+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Mon, 22 Jan 2018 03:40:01 +0530

armadillo (1:8.300.1+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Sun, 10 Dec 2017 09:43:58 +0530

armadillo (1:8.200.2+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Tue, 21 Nov 2017 07:14:33 +0530

armadillo (1:8.200.0+dfsg-3) unstable; urgency=medium

  * Upload to unstable
  * Fix copyright file to adhere to copyright format 1.0

 -- Kumar Appaiah <akumar@debian.org>  Mon, 06 Nov 2017 11:59:34 +0530

armadillo (1:8.200.0+dfsg-2) experimental; urgency=medium

  * Update and fix copyright to reflect new and corrected license and
    copyright holder details.

 -- Kumar Appaiah <akumar@debian.org>  Wed, 11 Oct 2017 08:56:05 +0530

armadillo (1:8.200.0+dfsg-1) experimental; urgency=medium

  * New upstream release
  * The new package (with soname) is libarmadillo8
  * Standards Version is now 4.1.1 (no changes)

 -- Kumar Appaiah <akumar@debian.org>  Tue, 10 Oct 2017 05:22:15 +0530

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Kumar Appaiah <akumar@debian.org>
-Build-Depends: debhelper (>= 7), libblas-dev, liblapack-dev, cmake, libarpack2-dev, dpkg-dev (>= 1.16.1~), libsuperlu-dev (>= 5.2)
-Standards-Version: 3.9.8
+Build-Depends: debhelper (>= 7), libblas-dev, liblapack-dev, cmake, libarpack2-dev, dpkg-dev (>= 1.16.1~), libsuperlu-dev (>= 5.2), quilt
+Standards-Version: 4.1.1
 Section: libs
 Homepage: http://arma.sourceforge.net/
 Vcs-Git: git://anonscm.debian.org/debian-science/packages/armadillo.git
@@ -13,7 +13,7 @@
 Section: libdevel
 Architecture: any
 Suggests: libitpp-dev
-Depends: libarmadillo7 (= ${binary:Version}), ${misc:Depends}, libarpack2-dev, libhdf5-dev, libsuperlu-dev (>= 5.2)
+Depends: libarmadillo8 (= ${binary:Version}), ${misc:Depends}, libarpack2-dev, libhdf5-dev, libsuperlu-dev (>= 5.2)
 Replaces: libarmadillo-doc (<= 1.1.2-1)
 Conflicts: libarmadillo-doc
 Description: streamlined C++ linear algebra library - Headers
@@ -25,7 +25,7 @@
  .
  This package has the development libraries and headers for Armadillo.
 
-Package: libarmadillo7
+Package: libarmadillo8
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}

=== debian/watch ===
version=4
opts=dversionmangle=s/\.dfsg\.\d+//,repacksuffix=+dfsg,compression=xz \
http://sf.net/arma/ armadillo-(.+)\.tar\.xz debian uupdate

## armadillo 9.100.5+dfsg

=== debian/changelog ===
armadillo (1:9.100.5+dfsg-1) unstable; urgency=medium

  * New upstream release
  * soname is now 9, add libarmadillo9 package
  * Remove band mattrix patch

 -- Kumar Appaiah <akumar@debian.org>  Thu, 16 Aug 2018 14:52:34 +0530

armadillo (1:8.400.0+dfsg-3) unstable; urgency=medium

  * Add patch from upstream to fix band matrix bug.
  * Move VCS details to Debian Salsa.

 -- Kumar Appaiah <akumar@debian.org>  Fri, 18 May 2018 16:54:54 +0530

## armadillo 9.100.6+dfsg

=== debian/changelog ===
armadillo (1:9.100.6+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Update watch file to avoid RC releases.

 -- Kumar Appaiah <akumar@debian.org>  Mon, 29 Oct 2018 22:04:27 +0530

## armadillo 9.200.6+dfsg

=== debian/changelog ===
armadillo (1:9.200.6+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Tue, 11 Dec 2018 10:47:39 +0530

## armadillo 9.200.7+dfsg

=== debian/changelog ===
armadillo (1:9.200.7+dfsg-1) unstable; urgency=medium

  * New upstream release (Closes: #920015)

 -- Kumar Appaiah <akumar@debian.org>  Mon, 21 Jan 2019 21:22:55 +0530

=== debian/control ===
--- 
+++ 
@@ -6,14 +6,14 @@
 Standards-Version: 4.1.1
 Section: libs
 Homepage: http://arma.sourceforge.net/
-Vcs-Git: git://anonscm.debian.org/debian-science/packages/armadillo.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/armadillo.git
+Vcs-Git: https://salsa.debian.org/science-team/armadillo.git
+Vcs-Browser: https://salsa.debian.org/science-team/armadillo
 
 Package: libarmadillo-dev
 Section: libdevel
 Architecture: any
 Suggests: libitpp-dev
-Depends: libarmadillo8 (= ${binary:Version}), ${misc:Depends}, libarpack2-dev, libhdf5-dev, libsuperlu-dev (>= 5.2)
+Depends: libarmadillo9 (= ${binary:Version}), ${misc:Depends}, libarpack2-dev, libhdf5-dev, libsuperlu-dev (>= 5.2)
 Replaces: libarmadillo-doc (<= 1.1.2-1)
 Conflicts: libarmadillo-doc
 Description: streamlined C++ linear algebra library - Headers
@@ -25,7 +25,7 @@
  .
  This package has the development libraries and headers for Armadillo.
 
-Package: libarmadillo8
+Package: libarmadillo9
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
